;PROGRAMA PARA APLICACIONES CON EL 8051


         CPU       "8051.TBL"
         HOF       "INT8"

DPORT:  EQU    90H          ;PUERTO DE DATOS P1
CPORT:  EQU    0B0H         ;DIRECCION PUERTO P3
   


ACC:    EQU    0E0H         ;ACUMULADOR
IE:     EQU    0A8H         ;HABILITACION INTERRUPCIONES
SP:     EQU    81H          ;STACK
PSW:    EQU    0D0H         ;PROGRAM STATUS WORD
SCON:   EQU    98H          ;CONTROL SERIE
TMOD:   EQU    89H          ;MODO TIMER
TH1:    EQU    8DH          ;PARTE ALTA TIMER1
TL1:    EQU    8BH          ;PARTE BAJA TIMER1
TR1:    EQU    08EH         ;HABILITA TIMER1
SBUF:   EQU    99H          ;SEND BUFFER
TI:     EQU    099H         ;BIT DE TRANSMISION
RI:     EQU    098H         ;BIT DE RECEPCION


         ORG 0H


PRIN:    MOV   IE,#0H        ;
         MOV   SP,#64H       ;STACK A MITAD DE RAM
         MOV   PSW,#0H       ;
         ACALL INIPORT
         ACALL MENSA1        ;MENSAJE "DESEA ENVIAR UN PROGRAMA:"
         ACALL RETARDO       ;RETARDO
         CLR   RI
         MOV   A,SBUF        ;LO PONEMOS EN EL ACUMULADOR
         MOV   R3,A
         SUBB  A,#53H       ;ES UNA "S"
         JZ    QUESI
         AJMP  0100H
QUESI:   MOV   A,#0C0H   ;CODIGO DE RETORNO DE CARRO
         ACALL ENVIO
         MOV   A,#45H      ;"E"
         ACALL ENVIO
         MOV   A,#53H      ;"S"
         ACALL ENVIO
         MOV   A,#50H      ;"P"
         ACALL ENVIO
         MOV   A,#45H      ;"E"
         ACALL ENVIO
         MOV   A,#52H      ;"R"
         ACALL ENVIO
         MOV   A,#41H      ;"A"
         ACALL ENVIO
         MOV   A,#4EH       ;"N"
         ACALL ENVIO
         MOV   A,#44H       ;"D"
         ACALL ENVIO
         MOV   A,#4FH       ;"0"
         ACALL ENVIO
         MOV   A,#20H       ;"ESPACIO"
         ACALL ENVIO
         MOV   A,#52H       ;"R"
         ACALL ENVIO
         MOV   A,#45H       ;"E"
         ACALL ENVIO
         MOV   A,#43H       ;"C"
         ACALL ENVIO
         MOV   A,#49H       ;"I"
         ACALL ENVIO
         MOV   A,#42H       ;"B"
         ACALL ENVIO
         MOV   A,#49H       ;"I"
         ACALL ENVIO
         MOV   A,#52H       ;"R"
         ACALL ENVIO
         MOV   A,#2EH       ;"."
         ACALL ENVIO
         ACALL ENVIO
         ACALL ENVIO
CONT3:   ACALL RECEP
         SUBB  A,#3AH       ;VEMOS SI SON LOS DOS PUNTOS
         JZ    CONT1        ;SI SON LOS : CONT1
         MOV   A,#0C0H      ;"RETORNO DE CARRO"
         ACALL ENVIO
         MOV   A,#45H       ;"E"
         ACALL ENVIO
         MOV   A,#52H       ;"R"
         ACALL ENVIO
         ACALL ENVIO
         MOV   A,#4FH       ;"O"
         ACALL ENVIO
         MOV   A,#52H       ;"R"
         ACALL ENVIO
         AJMP  PRIN
CONT1:   ACALL RECEP
         MUL   A,#10H       ;RECIBIMOS LA DECENA DE CANTIDAD DE BYTES
         MOV   R4,A
         ACALL RECEP       ;LA UNIDAD DE CANTIDAD DE BYTES
         ADD   A,R4
         MOV   R4,A        ;EN R4 TENEMOS LA CANTIDAD DE BYTES
         JZ    CONT4       ;SI LA CANTIDAD DE BYTES ES CERO SALTO AL FINAL
         ACALL RECEP
         ACALL RECEP       ;2 BYTES CON CEROS
         ACALL RECEP
         MUL   A,#10H      ;DECENA DE LA DIRECCION PARTE ALTA
         MOV   R0,A
         ACALL RECEP       ;UNIDAD DE LA DIRECCION PARTE ALTA
         ADD   A,R0
         MOV   R0,A        ;PARTE ALTA DIRECCION EN R0
         ACALL RECEP
         MUL   A,#10H      ;DECENA DIRECCION PARTE BAJA
         MOV   R1,A
         ACALL RECEP       ;UNIDAD DIRECCION PARTE BAJA
         ADD   A,R1
         MOV   R1,A        ;PARTE BAJA DE LA DIRECCION EN R1
CONT2:   ACALL RECEP
         MUL   A,#10H      ;DECENA DE UN DATO
         MOV   R5,A
         ACALL RECEP       ;UNIDAD DE UN DATO
         ADD   A,R5
         MOVC  A,@DPTR     ;GUARDAMOS EL DATO EN SU DIRECCION
         DJNZ  R4,CONT2    ;SI NO ES CERO SALTA A CONT2
         AJMP  CONT3
CONT4    MOV   A,#0C0H     ;RETORNO DE CARRO
         ACALL ENVIO
         MOV   A,#4FH      ;"O"
         ACALL ENVIO
         MOV   A,#4BH      ;"K"
         ACALL ENVIO
         AJMP  0100H       ;SALTAMOS AL PROGRAMA






INIPORT: MOV   SCON,#50H   ;UART MODO 1 (8 BITS,1 PARO)
         MOV   TMOD,#21H   ;TIMER1 MODO2,TIMER0 MODO1
         MOV   TH1,#243    ;2400 BAUDIOS A 11.98080MHZ
         MOV   TL1,#243    ;RECARGAR TIMER1
         SETB  TR1         ;HABILITA TIMER1
         RET

ENVIO:   MOV   SBUF,A    ;LO COGEMOS DEL ACUMULADOR
         CLR   TI
EN_OK:   JNB   TI,EN_OK    ;ESPERA A QUE EL DATO HA SIDO ENVIADO
         CLR   TI
         RET   

RECEP:   JNB   RI,RECEP    ;ESPERA A QUE UN DATO ENTRE
         CLR   RI
         MOV   A,SBUF    ;LO PONEMOS EN EL ACUMULADOR
         RET


RETARDO: MOV     R3,#100
RETAR1:  MOV     R2,#255
RETAR2:  DJNZ    R2,RETAR2
         DJNZ    R3,RETAR1
         RET






MENSA1:  MOV   A,#0C0H   ;CODIGO DE RETORNO DE CARRO
         ACALL ENVIO
         MOV   A,#45H       ;"E"
         ACALL ENVIO
         MOV   A,#4EH       ;"N"
         ACALL ENVIO
         MOV   A,#56H       ;"V"
         ACALL ENVIO
         MOV   A,#49H       ;"I"
         ACALL ENVIO
         MOV   A,#41H       ;"A"
         ACALL ENVIO
         MOV   A,#52H       ;"R"
         ACALL ENVIO
         MOV   A,#20H       ;"ESPACIO"
         ACALL ENVIO
         MOV   A,#55H       ;"U"
         ACALL ENVIO
         MOV   A,#4EH       ;"N"
         ACALL ENVIO
         MOV   A,#20H       ;ESPACIO
         ACALL ENVIO
         MOV   A,#50H       ;"P"
         ACALL ENVIO
         MOV   A,#52H       ;"R"
         ACALL ENVIO
         MOV   A,#4FH       ;"0"
         ACALL ENVIO
         MOV   A,#47H       ;"G"
         ACALL ENVIO
         MOV   A,#52H       ;"R"
         ACALL ENVIO
         MOV   A,#41H       ;"A"
         ACALL ENVIO
         MOV   A,4DH        ;"M"
         ACALL ENVIO
         MOV   A,#41H       ;"A"
         ACALL ENVIO
         MOV   A,#20H       ;"ESPACIO"
         ACALL ENVIO
         MOV   A,#28H       ;"("
         ACALL ENVIO
         MOV   A,#53H       ;"S"
         ACALL ENVIO
         MOV   A,#2FH       ;"/"
         ACALL ENVIO
         MOV   A,#4EH       ;"N"
         ACALL ENVIO
         MOV   A,#29H       ;")"
         ACALL ENVIO
         MOV   A,#3AH       ;":"
         ACALL ENVIO
         RET


